<template>
	<div class="app-container">
		<!-- 搜索区域 -->
		<el-form :model="queryParams" ref="queryRef" v-show="showSearch" :inline="true" label-width="80px">
			<el-form-item label="赛事编号" prop="matchNumStr">
				<el-input v-model="queryParams.matchNumStr" placeholder="请输入赛事编号" clearable style="width: 240px"
					@keyup.enter="handleQuery" />
			</el-form-item>
			<el-form-item label="联赛类型" prop="leagueAbbName">
					<el-select v-model="queryParams.leagueAbbName" @change="handleQuery" style="width: 240px" clearable placeholder="请选择联赛类型">
                  <el-option
                     v-for="item in dataScopeOptions"
                     :key="item.value"
                     :label="item.label"
                     :value="item.value"
                  ></el-option>
               </el-select>
			</el-form-item>

			<el-form-item label="时间">
				<el-date-picker v-model="dateRange" value-format="YYYY-MM-DD" type="daterange" range-separator="-"
					start-placeholder="开始日期" end-placeholder="结束日期" style="width: 240px"></el-date-picker>
			</el-form-item>
			<el-form-item>
				<el-button type="primary" icon="Search" @click="handleQuery" :loading="loading">查询</el-button>
				<el-button icon="Refresh" @click="resetQuery" :loading="loading">重置</el-button>
				
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
              <el-col :span="1.5">
                <el-button type="warning" plain icon="Download" @click="handleExport">导出</el-button>
              </el-col>
              <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
        </el-row>

		<!--loading-->
		<div
			v-if="loading"
			v-loading="loading"
			class="loading-page"
			element-loading-text="正在加载..."
			style="width: 100%; height: calc(100vh - 250px)"
		></div>
		<div v-else-if="pageList.length && !loading">
			<!-- 表格数据 -->
			<el-table v-loading="loading" :data="pageList">
				<el-table-column label="赛事编号" prop="matchNumStr" />
				<el-table-column label="联赛" prop="leagueAllName" :show-overflow-tooltip="true" />
				<el-table-column label="主队" prop="homeTeamAllName" :show-overflow-tooltip="true" />
				<el-table-column label="客队" prop="awayTeamAbbName" />
				<el-table-column label="赛果" prop="matchId">
					<template #default="scope">
						<el-popover placement="bottom" :width="360">
							<template #reference> 
								<el-button link type="primary" @dblclick="handleJumpLink(scope.row)">查看</el-button>
							</template>
							<template #default> 
								<div>
									<el-table border :data="scope.row.matchResults">
										<el-table-column label="游戏" prop="matchNumStr">
											<template #default="item">
												{{ item.row.codeName }}
											</template>
										</el-table-column>
										<el-table-column label="开赛结果" prop="reportSatus">
											<template #default="item"> 
												<el-tag type="error">{{ item.row.combinationDesc }}</el-tag>
											</template>
										</el-table-column>
										<el-table-column label="奖金" prop="matchNumStr">
											<template #default="item">
												{{ item.row.odds }}
											</template>
										</el-table-column>
									</el-table>
								</div>
							</template>
						</el-popover>
					</template>
				</el-table-column>
				<el-table-column label="AI预测" prop="matchId">
					<template #default="scope">
						<el-popover placement="bottom" :width="360">
							<template #reference> 
								<el-button link type="primary">查看</el-button>
							</template>
							<template #default> 
								<EditHad :data="scope.row" />
							</template>
						</el-popover>
					</template>
				</el-table-column>
				<el-table-column label="报告信息" prop="reportSatus">
					<template #default="scope">
						{{ scope.row.reportSatus === 1 ? scope.row.reportDetail.reportFlag : '' }}
					</template>
				</el-table-column>
                <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
					<template #default="scope">
						<el-tooltip content="编辑" placement="top" v-if="scope.row.reportSatus === 1">
							<el-button link type="primary" icon="Edit" @click="openDialog(scope.row)">编辑</el-button>
						</el-tooltip>
					</template>
				</el-table-column>
			</el-table>

			<!-- 分页区域 -->
			<pagination 
			:show="total > 0"
			:total="total" 
			v-model:page="queryParams.pageNum"
			v-model:limit="queryParams.pageSize" 
			@pagination="getList" />
		</div>
		<lz-page-empty v-else-if="!loading" :type="'2'">
			<lz-svg-icon icon-class="empty2" style="font-size: 312px;"/>
		</lz-page-empty>


		<!-- 修改对话框 -->
		<el-dialog :title="dialogTitle" v-model="dialogOpen" width="600px" append-to-body>
			<EditHad :data="dialogForm"  type="edit" v-if="dialogOpen" @submit="submitForm" ref="editHadRef"/>
			<template #footer>
				<div class="dialog-footer">
					<el-button type="primary" @click="submitForm">确 定</el-button>
					<el-button @click="cancel">取 消</el-button>
				</div>
			</template>
		</el-dialog>
	</div>
</template>

<script setup name="OperationReport">
import { Info, infoSelectDistinctLeagueAbbNames, reportUpdate } from "@/api/tc/eventAnalysisReport"
import { jumpLink } from "@/utils/tc"

import { processMatchResults } from "@/utils/tc"
import EditHad from "@/views/tc/eventAnalysisReport/components/EditHad.vue"

import { ref } from "vue"

const router = useRouter()
const { proxy } = getCurrentInstance()
const pageList = ref([])
const loading = ref(false)
const showSearch = ref(true)
const total = ref(0)
const dateRange = ref([])
const editHadRef = ref(null)

const dialogOpen = ref(false)
const dialogTitle = ref('编辑')
const dialogForm = ref({})

/** 数据范围选项*/
const dataScopeOptions = ref([])

const data = reactive({
	form: {},
	queryParams: {
		pageNum: 1,
		pageSize: 10,
		matchNumStr: undefined,
		leagueAbbName: undefined,
	},
	rules: {},
})

const { queryParams } = toRefs(data)


/** 导出按钮操作 */
function handleExport() {

	//   proxy.download("system/user/export", {
//     ...queryParams.value,
//   },`user_${new Date().getTime()}.xlsx`)
}

/** 提交表单 */
function submitForm() {
	const data = editHadRef.value.getFormData()
	reportUpdate(data).then(response => { 
		proxy.$message.success(response.msg)
		getList()
	}).finally(() => { 
		dialogOpen.value = false
	})
}

/** 取消按钮 */
function cancel() {
	dialogOpen.value = false
	dialogForm.value = {}
}

function openDialog(row) { 
	dialogForm.value = row
	dialogOpen.value = true
}

/** 获取联赛类型 */
function getLeagueAbbNames() {
	infoSelectDistinctLeagueAbbNames().then(response => {
		dataScopeOptions.value = response.rows ? response.rows.map(item => ({ value: item, label: item })) : []
	})
}

/** 跳转链接 */
function handleJumpLink(row) {
	jumpLink(row.matchId, 1)
}

/** 查看详情 */
function handleView(row) {
	if (row.reportSatus != 1) {
		return
	}
	// window.open(window.location.origin + '/#/tc/eventAnalysisReport/detail?id=' + row.matchId)
	router.push({
		path: '/tc/eventAnalysisReport/detail',
		query: {
			id: row.matchId
		}
	})
}

/** 查询列表 */
function getList() {
	loading.value = true
	const data = { ...queryParams.value }
	if (dateRange.value && dateRange.value[0] && dateRange.value[1]) {
		data.beginTime = dateRange.value[0]
		data.endTime = dateRange.value[1]
	} else {
		data.beginTime = undefined
		data.endTime = undefined
	}
	Info(data).then(response => {
		const res = response.rows.map(item => ({ 
			...item, 
			matchResults: item.matchResults ? processMatchResults(item.matchResults): null 
		}));
		pageList.value = res	
		total.value = response.total
	}).finally(() => {
		loading.value = false
	})
}

/** 搜索按钮操作 */
function handleQuery() {
	queryParams.value.pageNum = 1
	getList()
}

/** 重置按钮操作 */
function resetQuery() {
	dateRange.value = []
	proxy.resetForm("queryRef")
	handleQuery()
}

onMounted(() => {
	// 联赛类型
	getLeagueAbbNames()
	// 列表查询
	getList()
})
</script>